// JavaScript Document
$(document).ready(function(e) {
	// ** Timeline Indicators
	var totalButtons = $('.carousel .carousel-indicators > li').length;
	var counter = -1;
    $('.carousel .carousel-indicators > li').each(function(index, element){
    	var tabIndex = index + 1;
    	$(this).attr('id', 'btn'+tabIndex);
    	counter += 2;
    	$(this).attr('tabindex', counter);
    	$(this).attr('role', 'tab');
    	$(this).attr('aria-selected', false);
    	$(this).attr('aria-posinset', tabIndex);
    	$(this).attr('aria-setsize', totalButtons);
    	$(this).attr('aria-controls', 'slidecontent'+tabIndex);
    	$(this).attr('aria-disabled', false);
    	//$(this).attr('aria-label', 'Item '+tabIndex+' of '+totalButtons+'. '+$(element).text());
    });
    $('.carousel .carousel-indicators > li:first').attr('aria-selected', true).attr('aria-disabled', true);

	var counter = 0;
	// ** Timeline Body Content
    $('.carousel .carousel-inner > .item').each(function(index, element){
    	var tabIndex = index + 1;
		$(this).attr('id', 'slidecontent'+tabIndex);
		counter += 2;
    	$(this).attr('tabindex', counter);
    	$(this).attr('aria-hidden', true);
    	$(this).attr('aria-expanded', false);
		$(this).attr('aria-labelledby', 'btn' + tabIndex);
		$(this).attr('role', 'tabpanel');
		//$(this).attr('role', 'presentation');
    });
    $('.carousel .carousel-inner > .item.active').attr('aria-hidden', false).attr('aria-expanded', true)/*.attr('role', 'alert')*/;

	// ** Event Handlers
	$('.carousel').attr('data-activeSlide', 'slidecontent1').attr('data-activeIndicator', 'btn1');

    $('.carousel').on('slid', function(event){
    	setTimeout(delayFunction, 100);
    });

    function delayFunction(){
    	//console.log("Prev Indicator = "+activeSlideIndicatorID+" : "+activeSlideID+' :: '+$('#'+activeSlideIndicatorID).attr('id'));
    	//console.log("Prev Indicator = "+$('.carousel').attr('data-activeSlide')+" : "+$('.carousel').attr('data-activeIndicator'));
    	var activeSlide = $('.carousel').attr('data-activeSlide'),
    		activeIndicator = $('.carousel').attr('data-activeIndicator');

		$('#' + activeIndicator).attr('aria-selected', false).attr('aria-disabled', false);

		activeIndicator = $('.carousel .carousel-indicators li.active').attr('id');
		activeSlide = $('.carousel .carousel-inner > .item.active').attr('id');

		$('#' + activeIndicator).attr('aria-selected', true).attr('aria-disabled', true);
		$('#' + activeSlide).attr('aria-hidden', false).attr('aria-expanded', true).attr('role', 'alert').focus();
		//$('.carousel-inner').attr('role', 'alert');
		//$('.carousel-inner').focus();

		$('.carousel').attr('data-activeIndicator', activeIndicator);
		$('.carousel').attr('data-activeSlide', activeSlide);
	}


    $('.carousel').carousel({
        interval : false
    });

    $('.carousel').bind('slid', updateCarouselArrowStates);
    $('.carousel').find('.carousel-control.left').on('click', slideshowCarrouselEventHandler);
    $('.carousel').find('.carousel-control.right').on('click', slideshowCarrouselEventHandler);

    //-- Disable back button on load
    $('.carousel').find('.carousel-control.left').addClass('disabled').attr('aria-disabled', 'true');
    var totalPgs = $('.carousel').find('.item').length;
    updatePageNumber();

    function slideshowCarrouselEventHandler(e) {
        if ($(e.currentTarget).hasClass('disabled')) {
            return false;
        }
    }

    function updateCarouselArrowStates(e) {
        // console.log("updateCarouselArrowStates() | " + $('.carousel').find('.item').length);
        var rightArrow = $('.carousel').find('.carousel-control.right');
        var leftArrow = $('.carousel').find('.carousel-control.left');
        var lastItemActive = $('.carousel').find('.item').last().hasClass('active');
        (lastItemActive) ? rightArrow.addClass('disabled').attr('aria-disabled', 'true') : rightArrow.removeClass('disabled').attr('aria-disabled', 'false');
        var firstItemActive = $('.carousel').find('.item').first().hasClass('active');
        (firstItemActive) ? leftArrow.addClass('disabled').attr('aria-disabled', 'true') : leftArrow.removeClass('disabled').attr('aria-disabled', 'false');
        /*$('.item').removeAttr('role');
        $('.item.active').attr('role', 'alert');*/
        updatePageNumber();
    }

    function updatePageNumber() {
    	var index=$('.carousel').find('.item.active').index();
        $('.carousel-pg-wrap > ul > li').removeClass('active');
        $('.carousel-pg-wrap > ul > li').eq(index).addClass('active');
    }

});
