// JavaScript Document

$(document).ready(function(e) {
	var currentTab = 1;

	var counter = -1;
	var totalButtons = $('.vert-tab-btn, .hori-tab-btn').length;
	//$('.vert-tab-btn, .hori-tab-btn').attr('role', 'button');
	$('.vert-tab-btn, .hori-tab-btn').addClass('enabled');
	$('.vert-tab-btn, .hori-tab-btn').attr('role', 'tab').attr('aria-setsize', $('.vert-tab-btn, .hori-tab-btn').length);
	$('.vert-tab-btn, .hori-tab-btn').each(function(index) {
		var tabNo = $(this).attr('id').substr(3);
		counter += 2;
    	$(this).attr('tabindex', counter);
    	$(this).attr('role', 'tab');
    	$(this).attr('aria-selected', false);
    	$(this).attr('aria-posinset', (index+1));
    	$(this).attr('aria-setsize', totalButtons);
    	$(this).attr('aria-controls', 'txt'+tabNo);
    	$(this).attr('aria-disabled', false);
		//$(this).attr('tabindex', (index + 1)).attr('aria-controls', 'txt' + tabNo).attr('aria-posinset', (index + 1));
	});
	$('.hori-tab-btn-container>#btn' + currentTab).removeClass('enabled').addClass('disabled').attr('aria-selected', true).attr('aria-disabled', true);

	var counter = 0;
	$('.vert-tab-text-container div, .hori-tab-text-container > div').addClass('hidden');
	$('.vert-tab-text-container div#txt' + currentTab + ', .hori-tab-text-container div#txt' + currentTab).removeClass('hidden');
	$('.vert-tab-text-container div[id^="txt"], .hori-tab-text-container div[id^="txt"]').each(function(index) {
		var tabNo = $(this).attr('id').substr(3);
		counter += 2;
		$(this).attr('tabindex', counter);
    	$(this).attr('aria-hidden', true);
    	$(this).attr('aria-expanded', false);
		$(this).attr('aria-labelledby', 'btn' + tabNo);
		//$(this).attr('role', 'tabpanel');
		$(this).attr('role', 'presentation');
	});
	$('#txt' + currentTab).attr('aria-hidden', false).attr('aria-expanded', true)/*.attr('role', 'alert')*/;

	$('.tab-container').attr('data-activeSlide', 'txt1').attr('data-activeIndicator', 'btn1');

	$('.vert-tab-btn, .hori-tab-btn').click(function(e) {
		e.preventDefault();
		var activeSlide = $('.tab-container').attr('data-activeSlide'),
    		activeIndicator = $('.tab-container').attr('data-activeIndicator');

		$('.hori-tab-btn-container>#'+activeIndicator).removeClass('disabled').addClass('enabled').attr('aria-selected', false).attr('aria-disabled', false);
		$('#'+activeSlide).attr('aria-hidden', true).attr('aria-expanded', false).attr('role', 'presentation').addClass('hidden');//.scrollTop()

		var tabNo = $(this).attr('id').substr(3);
		$(this).removeClass('enabled').addClass('disabled').attr('aria-selected', true).attr('aria-disabled', true);//.focus()
		$('div#txt' + tabNo).removeClass('hidden').attr('aria-hidden', false).attr('aria-expanded', true).attr('role', 'alert');//.focus()
		$('.tab-container').attr('data-activeSlide', 'txt'+tabNo).attr('data-activeIndicator', $(this).attr('id'));
	});

	/*$(document).keydown(function(event) {
		var keyCode = event.keyCode || event.which;
		//console.log('Key Pressed = ' + keyCode+" : "+$(document.activeElement).attr('id')+' : '+$(document.activeElement).hasClass('hori-tab-text-container'));
		//var tabsFocus = hasFocus('hori-tab-text-container') || hasFocus('vert-tab-text-container') || hasFocus('hori-tab-btn ') || hasFocus('vert-tab-btn ');
		var isTabFocused = hasFocus('tab-container');
		//console.log('TAB has Focus > ' + isTabFocused);
		if (keyCode == 9 && isTabFocused) {
			event.preventDefault();
			//var tabID = $('.vert-tab-text-container, .hori-tab-text-container').find('div[aria-expanded="true"]').attr('aria-labelledby');
			//console.log('Tab Key Pressed | Shift Key = ' + event.shiftKey + ' : Current Tab ID = ' + currentTab);
			if (event.shiftKey) {
				if ($('#btn' + currentTab).prev().attr('id') != undefined) {
					$('#btn' + currentTab).prev().focus();
					currentTab--;
				} else {
					$('.hori-tab-btn-container > a, .vert-tab-text-container > a').last().focus();
					currentTab = $('.hori-tab-btn-container > a, .vert-tab-text-container > a').length;
				}
			} else {
				if ($('#btn' + currentTab).next().attr('id') != undefined) {
					$('#btn' + currentTab).next().focus();
					currentTab++;
				} else {
					$('.hori-tab-btn-container > a, .vert-tab-text-container > a').first().focus();
					currentTab = 1;
				}

			}
		}
	});*/
});

/*
function hasFocus(classSelectorName) {
	//console.log(className + ' <<>> hasClass() | ' + $(document.activeElement).attr('class') + ' : ' + $(document.activeElement).hasClass(className));
	var target = document.activeElement;
	if (target !== null) {
		//console.log('hasClass() | '+$('.tab-container').has(target).length);
		if ($('.'+classSelectorName).has(target).length === 0) {
			return false;
		}
	}
	return true;
}*/

